/**
* @file MIDedit.cpp
* @brief MIDIf[^̕ҏW
* @author T.Modegi
* @date  2020.1.22
*/
#include "StdAfx.h"
#include "common.h"
#include "commparam.h"
#include "MIDfile.h"
#include "commdata.h"
#include "MIDedit.h"

MIDIMSG *MidiMsg_bck;
DWORD song_len_bck=0;

/**
* @fn delete_midinote
* @brief wꂽMIDIf[^im[gIEIt̑΁j폜
* @param ()  Ȃ
* @return Ȃ
* @sa 
* @detail select_midinote,select_midinote2̂Q̃m[gCxg
MIDIf[^\MidiMsg폜
*/
void delete_midinote()
{
	int i;
	if (select_midinote<0 || song_len<=0) return;
	for (i=select_midinote+1;i<select_midinote2;i++) {
		MidiMsg[i-1].ms=MidiMsg[i].ms;
		MidiMsg[i-1].com=MidiMsg[i].com;
		MidiMsg[i-1].note=MidiMsg[i].note;
		MidiMsg[i-1].vel=MidiMsg[i].vel;
		MidiMsg[i-1].chan=MidiMsg[i].chan;
	}
	if (select_midinote2<(int)song_len-1) {
	for (i=select_midinote2+1;i<(int)song_len;i++) {
		MidiMsg[i-2].ms=MidiMsg[i].ms;
		MidiMsg[i-2].com=MidiMsg[i].com;
		MidiMsg[i-2].note=MidiMsg[i].note;
		MidiMsg[i-2].vel=MidiMsg[i].vel;
		MidiMsg[i-2].chan=MidiMsg[i].chan;
	}
	}
	song_len -=2;
	select_midinote=select_midinote2= -1;
}

/**
* @fn update_midinote
* @brief wꂽMIDIf[^im[gIEIt̑΁jǉEύX
* @param (add)  ǉ̏ꍇTRUEAύX̏ꍇFALSE
* @return Ȃ
* @sa 
* @detail select_midinote,select_midinote2̂Q̃m[gCxgɑ΂
note_number,note_velocityɕύX邩A
select_midinote,select_midinote2̂Q̃m[gCxg̋ԂɁA
note_number,note_velocitŷQ̃m[gCxgǉB
*/
void update_midinote(BOOL add)
{
	int i,j,p,s,s2,ii;
	int note,sw,nb;
	BOOL dup;

	if (select_midinote<0 || song_len<=0) return;

	if (!add) {
	MidiMsg[select_midinote].note=note_number;
	MidiMsg[select_midinote].vel=note_velocity;
	MidiMsg[select_midinote2].note=note_number;
	MidiMsg[select_midinote2].vel=0;
	}

	dup=FALSE;
	note=MidiMsg[select_midinote].note;
	if (add==TRUE || note!=note_number) dup=TRUE;
//  m[gCxg̒ǉA܂̓m[gI܂̓m[gItCɂ
//  m[gCxg̑}܂͏̓ւ
	if (add==TRUE || note_time_on!=(int)MidiMsg[select_midinote].ms ||
		note_time_off!=(int)MidiMsg[select_midinote2].ms ) {
		if (song_len_bck>0) free(MidiMsg_bck);
		MidiMsg_bck=(MIDIMSG *)malloc(song_len*sizeof(MIDIMSG));
		for (i=0;i<(int)song_len;i++) {
			MidiMsg_bck[i].ms=MidiMsg[i].ms;
			MidiMsg_bck[i].com=MidiMsg[i].com;
			MidiMsg_bck[i].note=MidiMsg[i].note;
			MidiMsg_bck[i].vel=MidiMsg[i].vel;
			MidiMsg_bck[i].chan=MidiMsg[i].chan;
		}
		song_len_bck=song_len;

		if (add) {
			free(MidiMsg);
			MidiMsg=(MIDIMSG *)malloc((song_len+2)*sizeof(MIDIMSG));
		}

		i=j=0;
		p=0;
		s=s2= -1;
		while(i<(int)song_len) {
			if (p==0 && (int)MidiMsg_bck[i].ms>note_time_on) {
				MidiMsg[j].ms=note_time_on;
				MidiMsg[j].com=MidiMsg_bck[select_midinote].com;
				MidiMsg[j].note=note_number;
				MidiMsg[j].vel=note_velocity;
				MidiMsg[j].chan=MidiMsg_bck[select_midinote].chan;
				p=1;
				s=j;
				j++;
			}
			else if (p==1 && (int)MidiMsg_bck[i].ms>note_time_off) {
				MidiMsg[j].ms=note_time_off;
				MidiMsg[j].com=MidiMsg_bck[select_midinote2].com;
				MidiMsg[j].note=note_number;
				MidiMsg[j].vel=0;
				MidiMsg[j].chan=MidiMsg_bck[select_midinote2].chan;
				p=2;
				s2=j;
				j++;
			}
			if (add==TRUE || (i!=select_midinote && i!=select_midinote2)) {
				MidiMsg[j].ms=MidiMsg_bck[i].ms;
				MidiMsg[j].com=MidiMsg_bck[i].com;
				MidiMsg[j].note=MidiMsg_bck[i].note;
				MidiMsg[j].vel=MidiMsg_bck[i].vel;
				MidiMsg[j].chan=MidiMsg_bck[i].chan;
				j++;
			}
			i++;
		}

// Cm[gItSm[gCxgɈʒuꍇ
		select_midinote=s;
		if (s2<0) {
			MidiMsg[j].ms=note_time_off;
			MidiMsg[j].com=MidiMsg_bck[select_midinote2].com;
			MidiMsg[j].note=note_number;
			MidiMsg[j].vel=0;
			MidiMsg[j].chan=MidiMsg_bck[select_midinote2].chan;
			p=2;
			s2=j;
			j++;
		}
		select_midinote2=s2;
		song_len=j;
		dup=TRUE;
	}

// CԂ܂铯m[gio[dm[gCxg̃IEIt̕␳
	if (dup) {
		if (add==TRUE || song_len_bck>0) free(MidiMsg_bck);
		MidiMsg_bck=(MIDIMSG *)malloc(song_len*sizeof(MIDIMSG));
		for (i=0;i<(int)song_len;i++) {
			MidiMsg_bck[i].ms=MidiMsg[i].ms;
			MidiMsg_bck[i].com=MidiMsg[i].com;
			MidiMsg_bck[i].note=MidiMsg[i].note;
			MidiMsg_bck[i].vel=MidiMsg[i].vel;
			MidiMsg_bck[i].chan=MidiMsg[i].chan;
		}
		song_len_bck=song_len;

// Cm[gI܂铯m[gio[dm[gCxg̃T[`
		nb= -1;
		j=0;
		for (i=0;i<select_midinote;i++) {
			MidiMsg[j].ms=MidiMsg_bck[i].ms;
			sw=MidiMsg[j].com=MidiMsg_bck[i].com;
			note=MidiMsg[j].note=MidiMsg_bck[i].note;
			MidiMsg[j].vel=MidiMsg_bck[i].vel;
			MidiMsg[j].chan=MidiMsg_bck[i].chan;
			j++;
			if (note==note_number) {
				if (nb<0 && sw>=0x90 && sw<=0x9f)  {
					nb=note;
					if (MidiMsg_bck[i].ms==MidiMsg_bck[select_midinote].ms) {j--; nb= -1;}
				}
				else if (nb>=0 && sw>=0x80 && sw<=0x8f) nb= -1;
			}
		}

// Cm[gI܂铯m[gio[dm[gCxgm[gIt
		if (nb>=0) {
			MidiMsg[j].ms=MidiMsg_bck[select_midinote].ms;
			MidiMsg[j].com=MidiMsg_bck[select_midinote2].com;
			MidiMsg[j].note=nb;
			MidiMsg[j].vel=0;
			MidiMsg[j].chan=MidiMsg_bck[select_midinote].chan;
			j++;
// ̃m[gItECxg폜
			for (i=select_midinote+1;i<(int)song_len;i++) {
				note=MidiMsg_bck[i].note;
				sw=MidiMsg_bck[i].com;
				if (i!=select_midinote2 && note==nb && sw>=0x80 && sw<=0x8f) {
					MidiMsg_bck[i].com=0;
					break;
				}
			}
		}
		i=select_midinote;
		MidiMsg[j].ms=MidiMsg_bck[i].ms;
		MidiMsg[j].com=MidiMsg_bck[i].com;
		MidiMsg[j].note=MidiMsg_bck[i].note;
		MidiMsg[j].vel=MidiMsg_bck[i].vel;
		MidiMsg[j].chan=MidiMsg_bck[i].chan;
		j++;
		i++;

// Cm[gIt܂铯m[gio[dm[gCxg̃T[`
		nb=ii= -1;
		while(i<select_midinote2) {
			note=MidiMsg_bck[i].note;
			sw=MidiMsg_bck[i].com;
			if (sw>0 && note!=note_number) {
				MidiMsg[j].ms=MidiMsg_bck[i].ms;
				MidiMsg[j].com=MidiMsg_bck[i].com;
				MidiMsg[j].note=MidiMsg_bck[i].note;
				MidiMsg[j].vel=MidiMsg_bck[i].vel;
				MidiMsg[j].chan=MidiMsg_bck[i].chan;
				j++;
			}
			else {
				if (nb<0 && sw>=0x90 && sw<=0x9f) {nb=note; ii=i;}
				else if (sw>=0x80 && sw<=0x8f) {nb= -1; ii= -1;}
			}
			i++;
		}

		i=select_midinote2;
		MidiMsg[j].ms=MidiMsg_bck[i].ms;
		MidiMsg[j].com=MidiMsg_bck[i].com;
		MidiMsg[j].note=MidiMsg_bck[i].note;
		MidiMsg[j].vel=MidiMsg_bck[i].vel;
		MidiMsg[j].chan=MidiMsg_bck[i].chan;
		j++;
		i++;
// Cm[gIt܂铯m[gio[dm[gCxg炵ăm[gI
		if (nb>=0) {
			MidiMsg[j].ms=MidiMsg_bck[select_midinote2].ms;
			MidiMsg[j].com=MidiMsg_bck[ii].com;
			MidiMsg[j].note=nb;
			MidiMsg[j].vel=MidiMsg_bck[ii].vel;
			MidiMsg[j].chan=MidiMsg_bck[ii].chan;
			j++;
		}

		i=select_midinote2+1;
		while(i<(int)song_len) {
			if (MidiMsg_bck[i].com!=0) {
			MidiMsg[j].ms=MidiMsg_bck[i].ms;
			MidiMsg[j].com=MidiMsg_bck[i].com;
			MidiMsg[j].note=MidiMsg_bck[i].note;
			MidiMsg[j].vel=MidiMsg_bck[i].vel;
			MidiMsg[j].chan=MidiMsg_bck[i].chan;
			j++;
			}
			i++;
		}
		song_len=j;
	}

	if (song_len_bck>0) {
		free(MidiMsg_bck);
		song_len_bck=0;
	}
	select_midinote=select_midinote2= -1;
}

/**
* @fn change_midinote_pitch
* @brief SĂMIDIf[^im[gIEIt̑΁j̃m[gio[܂̓CxgύX
* @param (nshift)  m[gio[̃Vtg
* @param (tempo)  CxgE^CR[h̕ύX䗦
* @return Ȃ
* @sa 
* @detail
*/
void change_midinote_pitch(int nshift,int tempo)
{
	int i,j,n;
	int vel,note,sw;
	if (song_len<=0) return;

	j=0;
	for (i=0;i<(int)song_len;i++) {
		sw=MidiMsg[i].com;
		note=MidiMsg[i].note;
		vel=MidiMsg[i].vel;
		n=note+nshift;
		if (n>=0 && n<=127) {
			if (tempo!=100)
				MidiMsg[j].ms=MidiMsg[i].ms*100/tempo;
			else
				MidiMsg[j].ms=MidiMsg[i].ms;
			MidiMsg[j].com=sw; MidiMsg[j].note=n; MidiMsg[j].vel=vel;
			j++;
		}
	}
	song_len=j;
}

/**
* @fn calc_total_midi_energy
* @brief SĂMIDIf[^̃GlM[ixVeB~tԂ̑ajZo
* @param () Ȃ
* @return GlM[ảtԂ̕ϒl
* @sa 
* @detail
*/
int calc_total_midi_energy()
{
	int i;
	int vel,note,sw;
	int notetbl[256];
	int eng;
	if (song_len<=0) return(-1);

	for (i=0;i<128;i++) notetbl[i]= -1;
	for (i=0;i<128;i++) notetbl[i+128]=0;
	eng=0;
	for (i=0;i<(int)song_len;i++) {
		sw=MidiMsg[i].com;
		note=MidiMsg[i].note;
		vel=MidiMsg[i].vel;
		if (sw>=0x90 && sw<=0x9f) {
			if (notetbl[note]<0) {
				notetbl[note]=MidiMsg[i].ms;
				notetbl[note+128]=vel;
			}
		}
		else if (sw>=0x80 && sw<=0x8f) {
			if (notetbl[note]>=0) {
				eng+=notetbl[note+128]*(MidiMsg[i].ms-notetbl[note]);
				notetbl[note]= -1;
				notetbl[note+128]=0;
			}
		}
	}
	eng=(int)((double)eng/(double)(MidiMsg[song_len-1].ms-MidiMsg[0].ms));
	return(eng);
}

/**
* @fn midinote_filter
* @brief w肳ꂽx܂͎ԖMIDIf[^im[gIEItCxg΁j폜
* @param () Ȃ
* @return Ȃ
* @sa 
* @detail@w苭xflt_level_min,w莞flt_length_minŎw
flt_connectTRUȄꍇ͎OMIDIf[^̎ԎAs
*/
void midinote_filter()
{
	int i,j,dt,dv,p1,p2;
	int vel,note,sw;
	int notetbl[128*3];
	if (song_len<=0) return;

	for (i=0;i<128*3;i++) notetbl[i]= -1;
	if (flt_connect) {
	for (i=0;i<(int)song_len;i++) {
		sw=MidiMsg[i].com;
		note=MidiMsg[i].note;
		vel=MidiMsg[i].vel;
		if (sw>=0x90 && sw<=0x9f) {
			if (notetbl[note]>=0 && notetbl[note+128]>=0 && notetbl[note+256]>=0) {
				p1=notetbl[note+128];
				p2=notetbl[note+256];
				dt=MidiMsg[i].ms-MidiMsg[p2].ms;
				dv=vel-notetbl[note];
				if (dv<=flt_diff_level && dt<=flt_interval_max) {
					MidiMsg[p2].com=MidiMsg[i].com=0;
				}
				else {
					notetbl[note+128]=i;
				}
			}
			else {
				notetbl[note+128]=i;
			}
			notetbl[note]=vel;
			notetbl[note+256]= -1;
		}
		else if (sw>=0x80 && sw<=0x8f) {
			notetbl[note+256]=i;
		}
	}
	}

	for (i=0;i<128*3;i++) notetbl[i]= -1;
	for (i=0;i<(int)song_len;i++) {
		if (MidiMsg[i].com!=0) {
		sw=MidiMsg[i].com;
		note=MidiMsg[i].note;
		vel=MidiMsg[i].vel;
		if (sw>=0x90 && sw<=0x9f) {
			if (vel<flt_level_min) {
				MidiMsg[i].com=0;
			}
			else {
				notetbl[note]=i;
			}
		}
		else if (sw>=0x80 && sw<=0x8f) {
			if (notetbl[note]>=0) {
				p1=notetbl[note];
				dt=MidiMsg[i].ms-MidiMsg[p1].ms;
				if (dt<flt_length_min) {
					MidiMsg[p1].com=MidiMsg[i].com=0;
				}
			}
			else {
					MidiMsg[i].com=0;
			}
			notetbl[note]= -1;
		}
		}
	}

	j=0;
	for (i=0;i<(int)song_len;i++) {
		sw=MidiMsg[i].com;
		if (sw!=0) {
			MidiMsg[j].ms=MidiMsg[i].ms;
			MidiMsg[j].com=MidiMsg[i].com;
			MidiMsg[j].note=MidiMsg[i].note;
			MidiMsg[j].vel=MidiMsg[i].vel;
			MidiMsg[j].chan=MidiMsg[i].chan;
			j++;
		}
	}
	song_len=j;
}
