/**
* @file commdata.h
* @brief  WAVf[^MIDIf[^֘AO[oϐєz
* @author T.Modegi
* @date  2023.6.16
*/
extern BOOL batch_mode;
extern int file_mode;
extern int cur_bitrate;
extern int cur_harmony;

extern char filename[];
extern char filename2[];
extern char fname_bck[];
extern char fname_wav_bck[];
extern BOOL mess_file_close;

extern short *wavbuf;
extern int num_sample;
extern int wav_channel;
extern int sample_freq;
extern int bit_per_sample;

extern SIGMIDT *finbuf;
extern int num_finbuf;

extern SIGMID *sigbuf;
extern int num_record;
extern int	max_fftlevel;

extern MIDIMSG *MidiMsg;
extern DWORD song_len;
extern int total_stanza;
extern int stanza[];
extern int max_channel;
extern DWORD total_time;
extern DWORD abs_time;
extern int select_midinote;
extern int select_midinote2;

//  gϊ֘AO[oϐєz
extern int dft_note_cnt;
extern int dft_note_tbl[];
extern double *cycle_tbl;
extern int *width_tbl;
extern int *ift_work;
//extern int *amp_work;
extern short *sft_sintbl;
extern short *sft_costbl;
extern int *adr_tbl;
extern int last_adr_tbl;
extern int freq_resol[],freq_adr[],last_freq_adr;
extern int note_interval[];

extern int a3tuning_freq;
extern int fft_step;
extern int freq_resol_def;
extern BOOL variable_resol;
extern int freq_resol_base;
extern int note_length_ratio;

extern int scale_level;
extern BOOL abs_timecode;
extern BOOL fft_file_out;
extern BOOL recalc_mode;
