/**
* @file WAVfile.h
* @brief WAVt@C̓o͏
* @author T.Modegi
* @date  2023.12.24
*/
typedef struct { 
//	WORD  dum1[2];
	char tag[4]; // RIFF
	DWORD nBytes1;
	char tag2[4]; // WAVE
//	WORD  dum2[4];
//	DWORD nBytes2;
} WAVEFORMAT_HEAD1;
typedef struct { 
//	WORD  dum3[2];
	char  tag[4];
	DWORD nBytes;
} WAVEFORMAT_HEAD2;

typedef struct { 
    WORD  wFormatTag;       // see below 
    WORD  nChannels;        // see below 
    DWORD nSamplesPerSec;   // sample rate, in samples per second 
    DWORD nAvgBytesPerSec;  // see below 
    WORD  nBlockAlign;      // see below 
    WORD  wBitsPerSample;  // number of bits per sample
	WORD  cbSize;
} WAVEFORMAT_HEAD;

int Read_WAVfile(char fname[]);
BOOL	DirListDlgProc(int mode);
BOOL	DirListDlgProc2(int mode);

