/**
* @file WaveMidi.cpp
* @brief WindowsŃvÕGg[|Cg
* @author T.Modegi
* @date  2024.4.24
*/

#include "stdafx.h"
#include <commctrl.h>
#include <stdio.h>
#include "resource.h"
#include "common.h"
#include "initparam.h"
#include "initdata.h"
#include "MCI_proc.h"
#include "WAVfile.h"
#include "MIDfile.h"
#include "MIDout.h"
#include "MIDcnv_s4_mid.h"
#include "MIDedit.h"
#include "MIDcnv_main.h"
#include "MIDdraw.h"
#include "WAVdraw.h"
#include "INITfile.h"
#include "MIDdialog.h"
#include "MIDdialog2.h"

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE hInst;					// ݂̃CX^X
TCHAR szTitle[MAX_LOADSTRING];				// ^Cg o[ eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// ^Cg o[ eLXg
HWND hStatusWnd=NULL;
HWND hWnd_main;
HANDLE hThread=NULL;

int playback_mode=0;

// ̃R[h W[Ɋ܂܂֐̑O錾:
ATOM			MyRegisterClass( HINSTANCE hInstance );
BOOL			InitInstance( HINSTANCE, int );
LRESULT CALLBACK	WndProc( HWND, UINT, WPARAM, LPARAM );

/**
* @fn WinMain
* @brief GUIWindowsAvP[ṼGg[|Cg
* @param (hInstance) NWindowCX^X̃nh
* @param (hPrevInstance) p[^gp
* @param (lpCmdLine) p[^gp
* @param (nCmdShow) p[^gp
* @return bZ[Wp[^
* @sa@Read_INITfile
* @detail IDC_MIDIPLAY, ob`łł͖{֐RgAEg܂B
*/
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// TODO: ̈ʒuɃR[hLqĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[o XgO܂
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WAVEMIDI, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass( hInstance );

	// AvP[V̏s܂:
	if( !InitInstance( hInstance, nCmdShow ) ) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WAVEMIDI);
	batch_mode=FALSE;
	Read_INITfile();

	// C bZ[W [v:
	while( GetMessage(&msg, NULL, 0, 0) ) 
	{
		if( !TranslateAccelerator (msg.hwnd, hAccelTable, &msg) ) 
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}

	return msg.wParam;
}


/**
* @fn main
* @brief ob`ŃR\[AvP[ṼGg[|Cg
* @param (argc) R}hC̃p[^ivO܂ށj
* @param (argv) R}hC̃p[^izj
* @return Ȃ
* @sa@Read_INITfile,Read_WAVfile,fMIDcnv_main,Write_TXTfile,Write_MIDfile
* @detail GUIłł͖{֐RgAEg܂B
*/
/*
void main (int argc,char *argv[])
{
	int i,n,song_len,mode,j,v;

	printf("WAVaudio-MIDI Converter version 6.431 (Win32 Console Application,24-April,2024)\n");
	printf(" developer and copyrigtht: Toshio Modegi\n");
	if (argc<2) {
		printf("Usages: WaveMidi_batch.exe filename[.wav] [options]\n");
		printf("   filename: Specify WAV-format nocompresed audio file\n");
		printf("             (Created MIDI-format file: filename.txt/mid)\n");
		printf("[Option Parameters]\n");
		printf("  f:0/1/2, Output File Format 0:TXT, 1:SMF, 2:TXT and SMF [default]\n");
		printf("  o:0/1, Overtone Removal 0:Off [default], 1:On\n");
		printf("  m:0/1, Microtonal Analaysis 0:Off [default], 1:On\n");
		printf("  w:256-8192, Analysis Frame Size  [default:1024]\n");
		printf("  t:1-1536 Time Resolution Per Second  [default:1536]\n");
		printf("  b:1-90000 Output Bit-rate [bps]  [default:9000]\n");
		printf("  h:1--64, Number of Harmony [default:32]\n");
		exit(-1);
	}

	for (i=0;i<255;i++) filename[i]='\0';
	sscanf(argv[1],"%s",filename);
	n= -1;
	for (i=0;i<255;i++) {
		if (filename[i]=='\0') {n=i; break;}
	}
	if (filename[n-4]!='.' && filename[n-3]!='w' && filename[n-3]!='W' && n+4<255) {
		filename[n]='.';
		filename[n+1]='w';
		filename[n+2]='a';
		filename[n+3]='v';
	}

	if (Read_WAVfile(filename)>0) {
		printf("Wave file:%s reading successfully.\n",filename);
		total_time=(int)((double)num_sample*1000.0/(double)sample_freq);
		printf(" sampling:%d bit:%d channel:%d length[msec]:%d\n",
		   sample_freq,bit_per_sample,wav_channel,total_time);
	}
	else {printf("Wave file:%s reading Error!!\n",filename); exit(-1);}
	batch_mode=TRUE;
	Read_INITfile();

    mode=2;
	if (argc>2) {
	for (j=2;j<argc;j++) {
	    sscanf(&argv[j][2],"%d",&v);
		if (argv[j][0]=='f') {
			mode=v;
			printf("Output File Format:%d\n",mode);
		}
		else if (argv[j][0]=='o') {
		  if (v==1) overtone_correct=TRUE; else overtone_correct=FALSE;
			printf("Overtone Removal:%d\n",v);
		}
		else if (argv[j][0]=='m') {
		  if (v==1) {
		        fine_note=TRUE;
				slice_difflevel=30;
				slice_diffnote=16;
				max_harmony=15;
				max_bitrate=20000;
		  }
		  else  fine_note=FALSE;
		  printf("Microtonal Analaysis:%d\n",v);
		}
		else if (argv[j][0]=='w') {
		   fft_size=v;
		   printf("Analysis Frame Width:%d\n",fft_size);
		}
		else if (argv[j][0]=='t') {
		   time_unit=v;
		   printf("Time Resolution Per Second:%d\n",time_unit);
		}
		else if (argv[j][0]=='b') {
			max_bitrate=v;
		   printf("Output Bit-rate:%d\n",max_bitrate);
		}
		else if (argv[j][0]=='h') {
			max_harmony=v;
		   printf("Number of Harmony:%d\n",max_harmony);
		}
	}
	}

	printf("Now MIDI Conversion Start !\n");
	song_len=fMIDcnv_main();
	printf("\nMIDI Event Data:%d are created.\n",song_len);
	n= -1;
	for (i=0;i<255;i++) {
		if (filename[i]=='.' && filename[i+4]=='\0') {n=i; break;}
	}
	if (n>0 && song_len>0 && mode!=1) {
	filename[n+1]='t';
	filename[n+2]='x';
	filename[n+3]='t';
	if (Write_TXTfile(filename)>0) printf("TXT MIDI file is successfully created.\n");
	else {printf("Output File Creation ERROR\n"); exit(-1);}
	}
	if (n>0 && song_len>0 && mode>0) {
	filename[n+1]='m';
	filename[n+2]='i';
	filename[n+3]='d';
	if (Write_MIDfile(filename)>0) printf("SMF MIDI file is successfully created.\n");
	else {printf("Output File Creation ERROR\n"); exit(-1);}
	}
	exit(0);
}
*/

/**
* @fn MyRegisterClass
* @brief EBhE NX̓o^
* @param (hInstance) CX^X nh
* @return ATOM
* @sa
* @detail
*/
//
//  ֐: MyRegisterClass()
//
//  pr: EBhE NX̓o^
//
//  Rg:
//
//    ̊֐т̎gp͂̃R[h Windows 95 Őɒǉꂽ
//    'RegisterClassEx' ֐ Win32 VXě݊ێꍇ
//    ̂ݕKvƂȂ܂BAvP[VAAvP[VɊ֘At
//    ꂽX[ ACR擾ł悤Å֐ĂяoƂ
//    dvłB
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style		= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon		= LoadIcon(hInstance, (LPCTSTR)IDI_WAVEMIDI);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_WAVEMIDI;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx( &wcex );
}

/**
* @fn InitInstance
* @brief CX^X nh̕ۑƃC EBhE̍쐬
* @param (hInstance) CX^X nh
* @param (nCmdShow) 
* @return TRUE
* @sa
* @detail
*/
//
//   ֐: InitInstance(HANDLE, int)
//
//   pr: CX^X nh̕ۑƃC EBhE̍쐬
//
//   Rg:
//
//        ̊֐ł́ACX^X nhO[oϐɕۑAvO
//        C EBhE쐬\܂B
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^X nhۑ܂

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if( !hWnd ) 
   {
      return FALSE;
   }

   ShowWindow( hWnd, nCmdShow );
   UpdateWindow( hWnd );
   hWnd_main=hWnd;

   return TRUE;
}

/**
* @fn Redisplay_main
* @brief WAVg`܂MIDIsAm[̍ĕ`
* @param (hwnd) Window̃nh
* @param (hdc) \ReLXg̃nh
* @return Ȃ
* @sa Redisplay_WAV,Redisplay_MIDI,Redisplay_ALL
* @detail
*/
void Redisplay_main(HWND hwnd,HDC hdc)
{
	if (file_mode==1) Redisplay_WAV(hwnd,hdc);
	else if (file_mode==2) Redisplay_MIDI(hwnd,hdc);
}

/**
* @fn Update_Menu_Item
* @brief CEBhẼj[ڂ̗LE̕\s
* @param (hWnd) Window̃nh
* @param (init) TRUE:ݒAFALSEFr㐧
* @return Ȃ
* @sa 
* @detail
*/
void Update_Menu_Item(HWND hWnd,BOOL init)
{
	if (init)
	{
            EnableMenuItem(GetMenu(hWnd), IDM_MIDI_OPEN, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_WRITE_SMF, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_WRITE_TXT, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_PLAY_WAV, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_MIDI_CONV, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_MIDI_CONV2, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_STOP_CONV, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_MIDI_FILTER, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_CHANGE_PITCH, MF_GRAYED);
            EnableMenuItem(GetMenu(hWnd), IDM_NOTE_EDIT, MF_GRAYED);
	}
	else
	{
	if (playback_mode==0) EnableMenuItem(GetMenu(hWnd), IDM_STOP_PLAY, MF_GRAYED);
	else  EnableMenuItem(GetMenu(hWnd), IDM_STOP_PLAY, MF_ENABLED);
	if (num_sample>0 && hThread==NULL) {
		EnableMenuItem(GetMenu(hWnd), IDM_PLAY_WAV, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd), IDM_MIDI_CONV, MF_ENABLED);
		EnableMenuItem(GetMenu(hWnd), IDM_MIDI_CONV2, MF_ENABLED);
	}
	if (song_len>0 && hThread==NULL) {
        EnableMenuItem(GetMenu(hWnd), IDM_MIDI_OPEN, MF_ENABLED);
        EnableMenuItem(GetMenu(hWnd), IDM_WRITE_SMF, MF_ENABLED);
        EnableMenuItem(GetMenu(hWnd), IDM_WRITE_TXT, MF_ENABLED);
        EnableMenuItem(GetMenu(hWnd), IDM_STOP_CONV, MF_GRAYED);
        EnableMenuItem(GetMenu(hWnd), IDM_MIDI_FILTER, MF_ENABLED);
        EnableMenuItem(GetMenu(hWnd), IDM_CHANGE_PITCH, MF_ENABLED);
        EnableMenuItem(GetMenu(hWnd), IDM_NOTE_EDIT, MF_ENABLED);
	}
	if (hThread!=NULL) {
		EnableMenuItem(GetMenu(hWnd), IDM_MIDI_CONV, MF_GRAYED);
		EnableMenuItem(GetMenu(hWnd), IDM_MIDI_CONV2, MF_GRAYED);
        EnableMenuItem(GetMenu(hWnd), IDM_STOP_CONV, MF_ENABLED);
	}
	}
}

/**
* @fn WndProc
* @brief Windowj[ANVnh[
* @param (hwnd) NWindow̃nh
* @param (message) j[ANṼbZ[WID
* @param (wParam) bZ[W̃p[^
* @param (lParama) bZ[W̊gp[^
* @return Ȃ
* @sa InquirePlayerStatus,Inquire_Device,About,stopMCIFile,CloseDevice,CloseMIDIFile,Open_MIDIout,
DirListDlgProc,Read_WAVfile,Read_SMFfile,Read_MIDIraw,Write_MIDfile,Write_TXTfile,SetupMIDIProc,playMCIFile,
ParamMIDIconv1,ParamMIDIconv2,fMIDcnv_thread,fMIDcnv_main,
Setup_MIDIfilter,midinote_filter,Setup_Pitch,change_midinote_pitch,Setup_Display,
Setup_NoteEdit,Open_Manual,Redisplay_main,Select_MIDI,Update_Menu_Item
* @detail
*/
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	LRESULT status;
	RECT clrect,strect;
	PAINTSTRUCT ps;
	HDC hdc;
	DWORD threadID;
	int x,y;

	if (playback_mode==1 && InquirePlayerStatus()==FALSE)  playback_mode=0;
	else if (playback_mode==2 && Inquire_Device()==FALSE)  playback_mode=0;

// Control Enable/Disable Menu Items
	Update_Menu_Item(hWnd,FALSE);

	switch( message ) 
	{
		case WM_CREATE:
			InitCommonControls();
			hStatusWnd=CreateStatusWindow(WS_CHILD | WS_VISIBLE | CCS_BOTTOM | SBARS_SIZEGRIP,"",hWnd,101);
			SendMessage(hStatusWnd,SB_SETTEXT,0,
				(LPARAM)"WAVaudio-MIDI Converter Tool (WaveMidi version6.431), developed by Toshio Modegi");
			Update_Menu_Item(hWnd,TRUE);
			break;
//		case WM_QUIT:
//			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// j[Ỉ:
			switch( wmId ) 
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   InvalidateRect(hWnd, 0, TRUE);
				   break;
				case IDM_EXIT:
				   if (playback_mode==1) stopMCIFile();
				   else if (playback_mode==2) CloseDevice();
				   CloseMIDIFile();
				   DestroyWindow(hWnd);
				   break;
				case IDM_MIDI_OPEN:
					file_mode=2;
					if (playback_mode==0) Open_MIDIout();
					playback_mode=2;
					break;
				case IDM_STOP_PLAY:
					if (playback_mode==1) stopMCIFile();
					else if (playback_mode==2) CloseDevice();
					playback_mode=0;
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_FILE_READ:
					if (DirListDlgProc(0)) {
						Read_WAVfile(filename);
					}
					file_mode=1;
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_MIDI_READ:
					if (DirListDlgProc(2)) {
						cur_harmony=Read_SMFfile(filename);
						file_mode=2;
					}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_TEXT_READ:
					if (DirListDlgProc(1)) {
						cur_harmony=Read_MIDIraw(filename);
						file_mode=2;
					}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_WRITE_SMF:
					if (DirListDlgProc2(2)) {
						Write_MIDfile(filename);
					}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_WRITE_TXT:
					if (DirListDlgProc2(1)) {
						Write_TXTfile(filename);
					}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_SET_MIDI:
					DialogBox(hInst,(LPCTSTR)IDD_SETUP_MIDI,hWnd,(DLGPROC)SetupMIDIProc);
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_PLAY_WAV:
					file_mode=1;
					if (playback_mode==0)
						playMCIFile(hInst,hWnd,filename);
					playback_mode=1;
					break;
				case IDM_MIDI_CONV:
					status=DialogBox(hInst,(LPCTSTR)IDD_MIDI_CONV1,hWnd,(DLGPROC)ParamMIDIconv1);
					if (status!=IDOK) break;
					file_mode=1;
					status=DialogBox(hInst,(LPCTSTR)IDD_MIDI_CONV2,hWnd,(DLGPROC)ParamMIDIconv2);
					if (status==IDOK) {
						recalc_mode=FALSE;
						mess_file_close=FALSE;
						if (hThread==NULL)
							hThread=CreateThread(0,0,(LPTHREAD_START_ROUTINE)fMIDcnv_thread,
								(VOID *)hWnd,0,&threadID);
					}
					break;
				case IDM_STOP_CONV:
					if (hThread!=NULL) {
						mess_file_close=TRUE;
						TerminateThread(hThread,0);
						while(WaitForSingleObject(hThread,0)==WAIT_TIMEOUT)
						Sleep(1);
						hThread=NULL;
						recalc_mode=TRUE;
						fMIDcnv_main();
						recalc_mode=FALSE;
						file_mode=2;
				        InvalidateRect(hWnd, 0, TRUE);
					}
					break;
				case IDM_MIDI_CONV2:
					status=DialogBox(hInst,(LPCTSTR)IDD_MIDI_CONV2,hWnd,(DLGPROC)ParamMIDIconv2);
					if (status==IDOK) {
						fft_file_out=TRUE;
						recalc_mode=TRUE;
						mess_file_close=FALSE;
						if (hThread==NULL)
							hThread=CreateThread(0,0,(LPTHREAD_START_ROUTINE)fMIDcnv_thread,
								(VOID *)hWnd,0,&threadID);
					}
					break;
				case IDM_MIDI_FILTER:
					status=DialogBox(hInst,(LPCTSTR)IDD_MIDI_FILTER,hWnd,(DLGPROC)Setup_MIDIfilter);
					if (status==IDOK)  {midinote_filter(); file_mode=2;}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_CHANGE_PITCH:
					status=DialogBox(hInst,(LPCTSTR)IDD_SETUP_PITCH,hWnd,(DLGPROC)Setup_Pitch);
					if (status==IDOK)  {change_midinote_pitch(change_pitch_value,change_tempo_value); file_mode=2;}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_NOTE_EDIT:
					status=DialogBox(hInst,(LPCTSTR)IDD_NOTE_EDIT,hWnd,(DLGPROC)Setup_NoteEdit);
					if (status==IDOK)  {file_mode=2;}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_SETUP_DISPLAY:
					status=DialogBox(hInst,(LPCTSTR)IDD_DISPLAY,hWnd,(DLGPROC)Setup_Display);
					if (status==IDOK)  {file_mode=2;}
				    InvalidateRect(hWnd, 0, TRUE);
					break;
				case IDM_MANUAL:
					Open_Manual();
					break;
				default:
				    InvalidateRect(hWnd, 0, TRUE);
				   return DefWindowProc( hWnd, message, wParam, lParam );
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint (hWnd, &ps);
			Redisplay_main(hWnd,hdc);
			EndPaint( hWnd, &ps );
			break;
		case WM_ACTIVATE:
			InvalidateRect(hWnd, 0, TRUE);
			break;
		case WM_SIZE:
			GetClientRect(hWnd,&clrect);
			GetClientRect(hStatusWnd,&strect);
			MoveWindow(hStatusWnd,0,clrect.bottom-strect.bottom,
				LOWORD(lParam),HIWORD(lParam),TRUE);
			InvalidateRect(hWnd, 0, TRUE);
			break;
		case WM_DESTROY:
			if (playback_mode==1) stopMCIFile();
			else if (playback_mode==2) CloseDevice();
			CloseMIDIFile();
			PostQuitMessage( 0 );
			break;
		case WM_LBUTTONDOWN:
			if (file_mode==2) {
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				Select_MIDI(x,y);
			}
			InvalidateRect(hWnd, 0, TRUE);
			break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   DrawMenuBar(hWnd);
   return 0;
}
