/**
* @file initparam.h
* @brief  MIDIϊp[^֘AO[oϐilݒj
* @author T.Modegi
* @date  2023.6.27
*/
// MIDItݒ_CAO{bNX
int MIDI_device=0;
int MIDI_program=1;
int MIDI_tempo=100;
int MIDI_tone=0;
int MIDI_volume=127;
int MIDI_bank1=0;
int MIDI_bank2=0;
int MIDI_reverb=0;
int MIDI_chorus=0;

//MIDIϊEg͐ݒ_CAO{bNX
BOOL overtone_correct=FALSE;
BOOL fine_note=FALSE;
//
BOOL fundamental_correct=FALSE;
int max_overtone=2;
//
int fft_size=4096;
int overtone_level=100;
int variable_rate=150;
int slice_difflevel=10;
//int slice_difflevel=15;
int slice_diffnote=6;
BOOL save_param=FALSE;
//
BOOL variable_step=TRUE;
BOOL fine_pitchbend=TRUE;
BOOL fine_expression=TRUE;
BOOL double_frame_anal=FALSE;

//MIDIϊEMIDIf[^ϊݒ_CAO{bNX
int slice_interval=512;
BOOL variable_interval=TRUE;
int slice_diffnote_abs=8;
int maximum_level=95;
int minimum_level=5;
int key_min=21;
int key_max=108;
int slice_length=1;
int slice_level=1;
int max_harmony=32;
int time_unit=1536;
int max_bitrate=9000;
BOOL sec_connect_off=FALSE;
BOOL Cmajor_key=FALSE;
BOOL key_note[12]={TRUE,FALSE,TRUE,FALSE,TRUE,TRUE,FALSE,TRUE,FALSE,TRUE,FALSE,TRUE};

//MIDI\[hݒ_CAO{bNX
int time_start_disp=0;
int time_end_disp= -1;
int key_min_disp=19;
int key_max_disp=112;
//
BOOL disp_pitchbend=FALSE;
BOOL display_rect_event=TRUE;

//MIDIf[^tB^E_CAO{bNX
int flt_key_min=21;
int flt_key_max=108;
int flt_level_min=20;
int flt_length_min=300;
BOOL flt_connect=FALSE;
int flt_diff_level=10;
int flt_interval_max=100;

// MIDIm[gEp[^ҏW_CAO{bNX
int note_number=0;
int note_time_on=0;
int note_time_off=0;
int note_velocity=0;

//MIDIsb`Ee|ύXݒ_CAO{bNX
int change_pitch_value=0;
int change_tempo_value=100;
