/**
* @file common.h
* @brief  WAVf[^MIDIϊf[^֘A̍\̒`
* @author T.Modegi
* @date  2020.8.14
*/

typedef struct
{
	DWORD ms;  // logical time unit defined by time_unit
	unsigned char com;
	unsigned char note;
	unsigned char vel;
	unsigned char chan;
} MIDIMSG;

typedef struct sigmid {
  int pos;
  int length;
  short note,level;
}  SIGMID;

typedef struct sigmidc {
  int level;
  int note;
  int sub;
  int conn;
}  SIGMIDC;

typedef struct sigmidt {
  int pos;
  short note,level;
  int adr;
}  SIGMIDT;

typedef struct offbuf {
  int pos;
  short note,level;
  int chan;
}  OFFBUF;

typedef struct note_priority {
	int pos;
	int offpos;
	int value;
} NOTE_PRIORITY;

typedef struct fftprev{
	int sv;
	int cv;
} FFTPREV;
