/**
* @file commparam.h
* @brief  MIDIϊp[^֘AO[oϐ
* @author T.Modegi
* @date  2023.6.27
*/
// MIDItݒ_CAO{bNX
extern int MIDI_device;
extern int MIDI_program;
extern int MIDI_tempo;
extern int MIDI_tone;
extern int MIDI_volume;
extern int MIDI_bank1;
extern int MIDI_bank2;
extern int MIDI_reverb;
extern int MIDI_chorus;

//MIDIϊEg͐ݒ_CAO{bNX
extern BOOL overtone_correct;
extern BOOL fine_note;
//
extern BOOL fundamental_correct;
extern int max_overtone;
//
extern int fft_size;
extern int overtone_level;
extern int variable_rate;
extern int slice_difflevel;
extern int slice_diffnote;
extern BOOL save_param;
//
extern BOOL variable_step;
extern BOOL fine_pitchbend;
extern BOOL fine_expression;
extern BOOL double_frame_anal;

//MIDIϊEMIDIf[^ϊݒ_CAO{bNX
extern int slice_interval;
extern BOOL variable_interval;
extern int slice_diffnote_abs;
extern int maximum_level;
extern int minimum_level;
extern int key_min;
extern int key_max;
extern int slice_length;
extern int slice_level;
extern int max_harmony;
extern int time_unit;
extern int max_bitrate;
extern BOOL sec_connect_off;
extern BOOL Cmajor_key;
extern BOOL key_note[];

//MIDI\[hݒ_CAO{bNX
extern int time_start_disp;
extern int time_end_disp;
extern int key_min_disp;
extern int key_max_disp;
//
extern BOOL disp_pitchbend;
extern BOOL display_rect_event;

//MIDIf[^tB^E_CAO{bNX
extern int flt_key_min;
extern int flt_key_max;
extern int flt_level_min;
extern int flt_length_min;
extern BOOL flt_connect;
extern int flt_diff_level;
extern int flt_interval_max;

// MIDIm[gEp[^ҏW_CAO{bNX
extern int note_number;
extern int note_time_on;
extern int note_time_off;
extern int note_velocity;

//MIDIsb`Ee|ύXݒ_CAO{bNX
extern int change_pitch_value;
extern int change_tempo_value;
